﻿#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <math.h>

double dataprocess(double *, int);
void print(double *, int);

void main() {
	double data[42];
	int num = 0;

	printf("처리할 실수의 갯수는(40개 이하)? >> ");
	scanf("%d", &num);

	printf("\n처리할 실수 %d개를 입력하세요. >> \n", num);
	for (int i = 0; i < num; i++)
		scanf("%lf", data + i);

	dataprocess(data, num);

	printf("\n=========== 자료 처리 ============\n");
	printf("입력자료: ");
	print(data, num);
	printf("자료 합: %.2f\n", dataprocess(data, num));
	printf("자료 평균: %.2f\n", *(data + num));
	printf("자료 분산: %.2f\n", *(data + num + 1));
	printf("자료 표준편차: %.4f\n", sqrt(*(data + num + 1)));
	//printf("자료 표준편자: %d\n", data);
}

double dataprocess(double *p, int cnt)
{
	double sum = 0, sqsum = 0;
	for (int i = 0; i < cnt; i++)
	{
		sum += *p;
		sqsum += *p * *p;
		p++;
	}

	//평균 저장
	*p++ = sum / cnt;
	//분산 저장
	*p++ = sqsum / cnt;

	return sum;
};

void print(double *p, int cnt)
{
	//자료 출력
	for (int i = 0; i < cnt; i++)
		printf("%.2f ", *p++);
	printf("\n");
}

