#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <windows.h>

void gotoxy(int x, int y)
{
	COORD xy = { 0, 0 };
	xy.X = x; xy.Y = y; // X and Y coordinates
	SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), xy);
}

struct personscore {
	int number;
	char name[40];
	int mid;
	int final;
	int quiz;
};

typedef struct personscore pscore;

void appendscore(FILE *f, int cnt);
void searchscore(FILE *f, int cnt);
void printhead();
void printscore(FILE *f);

int main()
{
	FILE *f;
	char fname[] = "score.bin";
	int max = 0, chc;
	char menu[80];

	int select = 0;
	while (1)
	{
		printf("\n\t [1] л ߰");
		printf("\n\t [2] л ");
		printf("\n\t [3] л ˻");
		printf("\n\t [0]  \n");
		printf("\n\t[޴ ] >> ");
		fgets(menu, 80, stdin);
		sscanf(menu, "%d", &select);
		//scanf("%d", &select);
		if (!select)
			break;

		switch (select) {
		case 1:
			system("cls");
			if ((f = fopen(fname, "a+")) == NULL)
			{
				printf("  ʽϴ.\n");
				exit(1);
			}

			fseek(f, 0L, SEEK_END);
			max = ftell(f) / sizeof(pscore);
			//printf("%d\n", max);
			appendscore(f, max);
			//printscore(f);
			fclose(f);
			break;

		case 2:
			system("cls");
			if ((f = fopen(fname, "r")) == NULL)
			{
				printf("  ʽϴ.\n");
				exit(1);
			}
			printscore(f);
			fclose(f);
			break;

		case 3:
			system("cls");
			if ((f = fopen(fname, "r+")) == NULL)
			{
				printf("  ʽϴ.\n");
				exit(1);
			}

			fseek(f, 0l, SEEK_END);
			max = ftell(f) / sizeof(pscore);

			printf("\n ū ȣ л %dԴϴ. >> \n", max);
			printf("ã лȣ Էϼ. >> ");
			scanf("%d", &chc);

			if (1 <= chc && chc <= max)
				searchscore(f, chc);
			else
				printf("ȣ ߸ Է߽ϴ.\n");

			fclose(f);
			break;
		}
	}
	printf(" մϴ. \n");

	return 0;
}

void appendscore(FILE *f, int cnt) {
	pscore score;
	char line[80];

	printf("߰ ̸ (߰, ⸻, ) Էϼ.\n");
	fgets(line, 80, stdin);
	while (!feof(stdin)) 
	{
		sscanf(line, "%s %d %d %d",
			score.name, &score.mid, &score.final, &score.quiz);
		score.number = ++cnt;
		fwrite(&score, sizeof(pscore), 1, f);
		fgets(line, 80, stdin);
	}
}

void searchscore(FILE *f, int cnt)
{
	pscore score;
	long offset = (long)(sizeof(pscore) * (cnt - 1));
	fseek(f, offset, SEEK_SET);
	fread(&score, sizeof(pscore), 1, f);
	printf("\nã л  >> \n\n");
	fprintf(stdout, "%6d%18s%8d%8d%8d\n", score.number,
		score.name, score.mid, score.final, score.quiz);

	int ch = getchar();
}

int scn(FILE *f, char snme[])
{
	pscore score;
	int i = 0;
	rewind(f);
	while (!feof(f))
	{
		fread(&score, sizeof(pscore), 1, f);
		if ((strcmp(score.name, snme)) == 0) {
			printf("%6d%18s%8d%8d%8d\n", score.number,
				score.name, score.mid, score.final, score.quiz);
			i++;
		}
	}
	if (i == 0)
		printf("ġϴ ̸  ʽϴ.\n");
	return 0;
}

void printscore(FILE *f) {
	pscore score;

	rewind(f);
	printhead();
	fread(&score, sizeof(pscore), 1, f);
	while (!feof(f)) 
	{

		fprintf(stdout, "%6d%18s%8d%8d%8d\n", score.number,
			score.name, score.mid, score.final, score.quiz);
		fread(&score, sizeof(pscore), 1, f);
	}
	fprintf(stdout, "%s\n",
		"-------------------------------------------------");
}

void printhead()
{
	printf("\n\t ========= л  ========= \n\n");
	fprintf(stdout, "%s\n",
		"-------------------------------------------------");
	fprintf(stdout, "%6s%18s%8s%8s%8s\n",
		"ȣ", "̸", "߰", "⸻", "");
	fprintf(stdout, "%s\n",
		"-------------------------------------------------");
}
