﻿#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>

//홀수 마방진 구성하는 함수
void oddProcess(int tableSize);
//홀수 마방진을 출력하는 함수
void printResult(int tableSize);

int table[19][19];

int main(void)
{
	int tableSize = 0;

	do
	{
		printf("홀수 마방진을 구할 홀수 정수 n을 입력하세요.");
		printf(" n ==> ");
		scanf("%d", &tableSize);
	} while (tableSize <= 2 || tableSize % 2 == 0);

	oddProcess(tableSize);
	printResult(tableSize);

	return 0;
}

void oddProcess(int tableSize)
{
	// 첫 자료인 1이 들어갈 위치, 이 변수가 자료가 저장될 위치 : x(행), y(열)
	int x = 0, y = tableSize / 2;

	// 위치를 결정하기 이전의 위치 
	int xx, yy;

	for (int i = 1; i <= tableSize * tableSize; i++)
	{
		table[x][y] = i;

		//대각선 이동(오른쪽(y++) 위쪽(x--))
		xx = x--;
		yy = y++;

		//행은 음수 -1이 될 수 있으므로 + tableSize를 한 후 나머지 연산을 수행 
		x = (x + tableSize) % tableSize;
		y %= tableSize;

		if (table[x][y] != 0)
		{
			x = xx + 1;
			y = yy;
		}
	}
}

void printResult(int tableSize)
{
	printf("\n n이 %d인 마방진의 결과는 다음과 같습니다. \n\n", tableSize);

	int i = 0, j = 0;
	for (i = 0; i < tableSize; i++)
	{
		int sum = 0;
		for (j = 0; j < tableSize; j++)
		{
			sum += table[i][j];
			printf("\t%3d", table[i][j]);
		}
		printf("\t | %5d", sum);

		printf("\n");

		if (i == tableSize - 1)
		{
			for (j = 0; j < tableSize; j++)
			{
				printf("\t%3s", "---");
			};
			printf("\n");
			for (j = 0; j < tableSize; j++)
			{
				sum = 0;
				for (int k = 0; k < tableSize; k++)
					sum += table[k][j];
				printf("\t%3d", sum);
			};
			printf("\n");
		}
	}
}