﻿
#include <stdio.h>
#include <math.h>
#include <conio.h>
#include <windows.h>
#include <windows.h>

void gotoxy(int x, int y)
{
	// 콘솔의 X, Y 좌표 지정
	COORD position = { 0, 0 };
	position.X = x; position.Y = y;
	SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), position);
}

// 0: 검정색  1: 파란색  2: 녹색    3: 하늘색  4: 빨간색  5: 분홍색
// 6: 갈색    7: 연회색  8: 진회색  9: 연파랑 10: 연두색 11: 연하늘색 
//12: 연빨강 13: 연분홍 14: 노란색 15: 흰색
void SetColor(int ForgC)
{
	//현재의 백그라운드 속성을 가져오기
	HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);

	//속성에 필요한 정보 저장 변수 선언
	CONSOLE_SCREEN_BUFFER_INFO csbi;
	WORD wColor;
	//현재의 콘솔화면버퍼정보(csbi)를 가져오기
	if (GetConsoleScreenBufferInfo(hStdOut, &csbi))
	{
		//백그라운드 속성은 그대로 가져오고, 폰트 색상만 수정
		wColor = (csbi.wAttributes & 0xF0) + (ForgC & 0x0F);
		//콘솔 색상 수정
		SetConsoleTextAttribute(hStdOut, wColor);
	}
}

#define WIDTH 76
#define HEIGHT 22
#define X WIDTH / 2
#define Y HEIGHT / 2
//#define XMAX WIDTH-X-1
#define XMAX WIDTH - X
#define XMIN -(WIDTH - X)
#define YMAX HEIGHT - Y
//#define YMIN -(HEIGHT - Y) + 1
#define YMIN -(HEIGHT - Y)

//char grid[HEIGHT][WIDTH];
char grid[HEIGHT + 1][WIDTH + 1];
//double data[2][WIDTH + 2];
int xout[3] = { 0 };
int yout[7] = { 0 };


void init_grid(void);
//이차원 배열 grid에 가로축과 세로축, 좌표 0 그리기
int plot(int x, int y);
void show_grid(void);

int main()
{
	double x, y;
	init_grid();
	//for (x = -3.14159; x <= 3.14159; x += 0.1)
	for (x = -3.14159; x <= 3.24159; x += 0.1)
	{
		y = sin(x);
		//plot(rint(x * 10), rint(y * 8));
		plot((int)rint(x * 11), (int)rint(y * 10));
	}
	show_grid();

	//Y 좌표 출력
	SetColor(8);
	gotoxy(X - 1, 1); printf("1");
	gotoxy(X + 3, Y + 1); printf("0");
	gotoxy(X + 3, HEIGHT - 1); printf("-1");

	//X 좌표 출력
	gotoxy(3, Y - 1); printf("-3");
	gotoxy(WIDTH - 2, Y + 1); printf("3");

	gotoxy(0, HEIGHT + 2);
	return(0);
}

/* Initialize grid */
void init_grid(void)
{
	int x, y;

	for (y = 0; y<HEIGHT; y++)
		for (x = 0; x<WIDTH; x++)
			grid[y][x] = ' ';

	// 세로축 그리기
	for (y = 0; y <= HEIGHT; y++)
	{
		grid[y][X] = '|';
		//if (y == Y)
		//grid[y+1][X+2] = '0';
	}

	//for (x = 0; x < WIDTH; x++)
	for (x = 0; x <= WIDTH; x++)
		grid[Y][x] = '-';
	grid[Y][X] = '+';

}

/* Set "pixel" at specific coordinates */
int plot(int x, int y)
{
	if (x > XMAX || x < XMIN || y > YMAX || y < YMIN)
		return (-1);

	grid[Y - y][X + x] = '*';

	/*
	if (x / 11 == -3 && xout[0] == 0)
	{
	grid[Y - 1][X + x - 1] = '-';
	grid[Y - 1][X + x] = '3';
	xout[0] = 1;
	}
	*/

	return(1);
}

void show_grid(void)
{
	int x, y;

	//for (y = 0; y<HEIGHT; y++)
	for (y = 0; y <= HEIGHT; y++)
	{
		putchar(' ');
		//for (x = 0; x < WIDTH; x++) {
		for (x = 0; x <= WIDTH; x++)
		{
			if (grid[y][x] == '*')
				SetColor(12);
			else
				SetColor(9);
			putchar(grid[y][x]);
		}
		putchar('\n');
	}
}




