#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>
#include <windows.h>

void gotoxy(int x, int y)
{
	COORD coord = { 0,0 }; //Ŀ  ġ(top-left corner of window)
	coord.X = x; coord.Y = y;
	SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), coord);
}

void textcolor(int color_number)
{
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), color_number);
}

#define COLSIZE 20
#define ROWSIZE 30
#define SIZE COLSIZE * ROWSIZE

void init(void);
void printPrime(int num);
void checkprime(int prime[], int size, int end);
void printfileprime(int data[], int n, FILE *);

int prime[1001] = { 1 };

int main(void)
{
	int num = 1;
	init();

	gotoxy(0, 1);
	for (int devider = 2; devider <= (int)sqrt(COLSIZE * ROWSIZE); devider++)
	{
		num = 1;
		int isFirst = 1;
		for (int i = 1; i <= ROWSIZE; i++)
		{
			for (int j = 1; j <= COLSIZE; j++) {
				if (num % devider)
				{ // devider  
					if (num == 1) prime[num] = 0;
					printPrime(num);
				} else
				{ // devider 
					if (!isFirst)
					{ //ù  ƴϸ 
						prime[num] = 0;
						printf("%4c", 'X');
					}
					else
					{ //ù ̸
						printPrime(num);
						isFirst = 0;
					}
				}
				num++;
			}
			gotoxy(0, 1 + i);
		};
		gotoxy(0, 1);
	}
	gotoxy(0, 32);

	FILE *f;
	if (fopen_s(&f, "prime.txt", "w") != 0)
	{
		puts("  ʽϴ.");
		exit(0);
	};

	printfileprime(prime, SIZE, f);

	return 0;
}

void init(void)
{
	gotoxy(0, 1);
	int num = 1;
	for (int i = 1; i <= ROWSIZE; i++)
	{
		for (int j = 1; j <= COLSIZE; j++)
		{
			prime[num] = 1;
			printf("%4d", num++);
		}
		gotoxy(0, 1 + i);
	};
}

void printPrime(int num)
{
	if (prime[num])
		printf("%4d", num);
	else
	{
		textcolor(0x7772);
		printf("%4c", 'X');
	}
}

void printfileprime(int data[], int n, FILE *f)
{
	int i, count1 = 1, count2 = 1;
	printf("1 %d  Ҽ(prime number)\n", n);
	for (i = 2; i <= n; i++)
		if (data[i] == 1)
		{
			printf("%3d%c", i, count1++ == 20 ? (count1 = 1, '\n') : ' ');
			fprintf(f, "%3d%c", i, count2++ == 20 ? (count2 = 1, '\n') : ' ');
		}
	puts(""); puts("");
}

//Ҽ ˻
void checkprime(int prime[], int size, int type)
{
	int i, divisor, end;

	//3 size
	for (i = 3; i <= size; i++)
	{
		if (type == 1) end = i;
		else if (type == 2) end = i / 2;
		else end = (int)sqrt(i);

		//2 end   Ҽ ƴ
		for (divisor = 2; divisor <= end; divisor++)
			if ((divisor < i) && (i%divisor == 0)) prime[i] = 0;
	}
}

