// file: linkedlist.c
#include "linkedlist.h"

#include <windows.h>

void gotoxy(int x, int y)
{
	// ܼ X, Y ǥ 
	COORD position = { 0, 0 };
	position.X = x; position.Y = y;
	SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), position);
}

// 0:   1: Ķ  2:     3: ϴû  4:   5: ȫ
// 6:     7: ȸ  8: ȸ  9: Ķ 10: λ 11: ϴû 
//12:  13: ȫ 14:  15: 
void SetColor(int ForgC)
{
	// ׶ Ӽ 
	HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);

	//Ӽ ʿ    
	CONSOLE_SCREEN_BUFFER_INFO csbi;
	WORD wColor;
	// ܼȭ(csbi) 
	if (GetConsoleScreenBufferInfo(hStdOut, &csbi))
	{
		//׶ Ӽ ״ , Ʈ  
		wColor = (csbi.wAttributes & 0xF0) + (ForgC & 0x0F);
		//ܼ  
		SetConsoleTextAttribute(hStdOut, wColor);
	}
}

LINK createNode(char *name);
LINK append(LINK head, LINK cur);
LINK reverse(LINK head);

int printList(LINK head);
int drawList(char *str, LINK head, int left);

int main(void)
{
	//ǥԷ  α׷ ̸ ڿ   迭
	char name[30];
	LINK head = NULL; // Ʈ  
	LINK cur; //   带 Ű 

	printf("̸ Էϰ Enter . >> \n");
	while (gets(name) != NULL)
	{
		cur = createNode(name);	//  Ҵ
		if (cur == NULL) {
			printf("޸ Ҵ翡  ֽϴ.\n");
			exit(1);
		}
		head = append(head, cur);	// ڿ  ߰
		printList(head);		// Ʈ  
	}

	system("cls");
	
	drawList(" Ʈ()", head, 5);		// Ʈ  
	//ȣ
	head = reverse(head);
	drawList(" Ʈ()", head, 40);	// Ʈ  


	return 0;
}

//带 ϴ Լ
LINK createNode(char *name)
{
	// Ǵ  ּҸ   cur 
	LINK   cur;
	//Լ malloc() Ҵ  ּҸ  cur 
	cur = (LINK)malloc(sizeof(NODE));
	if (cur == NULL)
	{
		printf("   ޸ Ҵ翡  ֽϴ.\n");
		return NULL;
	}
	// ̸  ڹ迭  ҴϿ name   
	cur->name = (char *)malloc(sizeof(char) * (strlen(name) + 1));
	strcpy(cur->name, name);
	//  𸣹Ƿ NULL 
	cur->next = NULL;

	return cur;
}

//cur 带  Ʈ head  忡 ߰ϴ Լ
LINK append(LINK head, LINK cur)
{
	//  nextNode ϰ ʱ  head 
	LINK nextNode = head;
	//  尡 Ű  ٸ,  ḮƮ 尡 ϳ  
	if (head == NULL)
	{
		head = cur; //߰Ϸ 尡 head 
		return head;
	}
	// next NULL  ̵Ͽ   ̵
	while (nextNode->next != NULL)
	{
		nextNode = nextNode->next;
	}
	//߰ 带   next 
	nextNode->next = cur;

	return head;
}

// Ʈ    Լ
int printList(LINK head)
{
	int cnt = 0; //湮   
	LINK nextNode = head;
	//nextNode ̿Ͽ ḮƮ ó  ȸ
	while (nextNode != NULL)
	{
		//Ʈ  带 湮Ͽ 湮 Ƚ ڿ ڷḦ 
		printf("%3d°  %s\n", ++cnt, nextNode->name);
		nextNode = nextNode->next;
	}

	//  湮 Ƚ ȯϰ Լ 
	return cnt;
}

// Ʈ    Լ
LINK reverse(LINK head)
{
	int cnt = 0; //湮   

	LINK prev, cur, nextNode;
	cur = NULL;
	nextNode = head;
	//nextNode = head->next;

	//nextNode ̿Ͽ ḮƮ ó  ȸ
	while (nextNode != NULL)
	{
		//Ʈ  带 湮Ͽ 湮 Ƚ ڿ ڷḦ 
		//printf("%3d°  %s\n", ++cnt, nextNode->name);
		prev = cur;
		cur = nextNode;
		nextNode = nextNode->next;
		cur->next = prev;
	}

	//  湮 Ƚ ȯϰ Լ 
	return cur;
}


// Ʈ    Լ
int drawList(char *str, LINK head, int left)
{
	int x = left, y = 0;
	gotoxy(x-3, y++); printf("< %s >", str);
	y++;

	int cnt = 0; //湮   
	LINK nextNode = head;
	//nextNode ̿Ͽ ḮƮ ó  ȸ
	while (nextNode != NULL)
	{
		//Ʈ  带 湮Ͽ 湮 Ƚ ڿ ڷḦ 
		//printf("%3d°  %s\n", ++cnt, nextNode->name);
		x = left;
		gotoxy(x, y++); printf("[ %s ]", nextNode->name);

		nextNode = nextNode->next;
		x += 3;
		if (nextNode)
		{
			gotoxy(x, y++); printf("|");
			gotoxy(x, y++); printf("|");
			gotoxy(x, y++); printf("v");
		}
	}
	puts("");

	//  湮 Ƚ ȯϰ Լ 
	return cnt;
}

